#!/usr/bin/perl

# Manually set the day: billing.pl ddmmyy
# where ddmmyy is the day, for which the processing is required
# Example: billing.pl 150607

use LWP::Simple;

my $exclude;

my $base_path = "/home/phonestat/";
my $sourcelog_path = "/home/phonelogs/log/";
my $destlog_path = "/home/phonestat/";
my $zip_add = "/usr/bin/zip -m";
my $zip_ext = "/usr/bin/unzip";

my $sendmail = "/usr/sbin/sendmail -t -f root\@ufanet.ru";
my $notification_email = "trafik\@ufanet.ru";

#86400
my @t = localtime( time() - 86400 );

my $d = sprintf("%02d", $t[3]); 
my $m = sprintf("%02d", $t[4]+1);
my $y = sprintf("%02d", $t[5] % 100);

my $name = @ARGV > 0 ? $ARGV[0] : "$d${m}"."${y}";

chomp( $name );

my $logFile = $sourcelog_path.${name}.".txt";

unless(open( FILE, $logFile )) {

	 #print "Phonestat log file $logFile was not found.\n";
	 #exit 1;

	open(SENDMAIL, "|$sendmail") or die "Cannot open $sendmail: $!";
	print SENDMAIL "Subject: Phonestat notice\n";
	print SENDMAIL "From: root\@ufanet.ru\n";
	print SENDMAIL "To: $notification_email\n";
	print SENDMAIL "Content-type: text/plain; charset=utf-8\n\n";
	print SENDMAIL "Phonestat log file $logFile was not found.\n";
	close(SENDMAIL);

}

my %DATA;
my %DATAF;

LINE: while( <FILE> )
{

        # was: 23.11.2008 23:59:26  | 153    | 2 | 3472923090 | 89273114436          |
        # new: 003 : 018| 028 : 003| 01.10.2008 16:42:31  | 135    | 1 | 3472733254 | 3472900463           |
        if ( /^\s+(\d{3})\s:\s(\d{3})\|\s+(\d{3})\s:\s(\d{3})\|\s+(\d{2})\.(\d{2})\.(\d{4})\s+(\d{2}):(\d{2}):(\d{2})\s+\|\s+(\d+)\s+\|\s+(\d+)\s+\|\s+(\d*)\s+\|\s+(\d+)/ )
        {
                my ($port1_1, $port1_2, $port2_1, $port2_2, $dd, $mm, $yy, $h, $m, $s, $amount, $type, $from_num, $to_num)
                 = ($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14);

		# disabled 18.12.2008 according to Artur Kazakov
		# next if ( $amount == 1 );
		# next if ( $type !~ /^[23]$/ );
 		
		#Filtering according to Rashit Shabayev
		next if ( $to_num =~ /^19[1234]$/ );
		next unless ( $to_num =~ /(^[28]|^0[0-9]$|^3472)/ );

		$before = $to_num;
		if( $to_num =~ s/^07// )
		{
			warn "warning: 07* skipped ($before)\n";
			next;
		}
		
		# ВХОДЯЩИЙ: проверяем пустые номера
		$from_num='empty' if !$from_num;
		
		# ВХОДЯЩИЙ: если входящий - 10 цифр, приписываем слева 7
		if($from_num =~ s/^(\d{10})$/7$1/){;}
		else
		{
			warn "warning: strange FROM-num: <$from_num> ($dd.$mm.$yy $h:$m:$s)\n";
		}
		
		# приведение номеров к единому виду	(дополнение коротких до полных)
		$from_num_e164 = $from_num;		
		$to_num_e164 = normalizeNum2( $to_num );		

		# если ВХОДЯЩИЙ номер имеет длину 10 цифр и начинается не с '846', то приписываем слева '8'
		# если длина ровно 10 цифр
		#if($from_num =~ m/\A\d{10}\Z/)
		#{
		#	# если начинается на 846
 		#	if( $from_num =~ m/846\d{7}/)
 		#	{ 				
 		#	}
 		#	else
 		#	{
  		#		# ИНАЧЕ (то есть начинается не на 846) приписываем слева восьмерку: +7
 		#		$from_num  ="7". $from_num;
 		#	}
		#}
		
		# приводим к Е.164
		#$from_num_e164 = num2e164( $from_num );
		#$to_num_e164 = num2e164( $to_num_e164 );		

		# приведение портов к нужному виду
	#	$plata_port1 = normalizePort( $plata_port1 );
	#	$plata_port2 = normalizePort( $plata_port2 );
	#	$plata_port1 = 0;
	#	$plata_port2 = 0;
		$plata_port1 = $port1_1.$port1_2;
		$plata_port2 = $port2_1.$port2_2;
	
		$new = 1;	
		$key = $yy."_".$mm."_".$dd."_".$h."_".$m."_".$s."_".$from_num_e164."_".$to_num_e164."_".$type."_".$amount;		
		# possible variants of the call, made due to an advice of Rashit Shabayev
		$calls[0] = $yy."_".$mm."_".$dd."_".$h."_".$m."_".$s."_".$from_num_e164."_".$to_num_e164."_".$type."_".$amount;		
		$calls[1] = $yy."_".$mm."_".$dd."_".$h."_".$m."_".($s-1)."_".$from_num_e164."_".$to_num_e164."_".$type."_".$amount;		
		$calls[2] = $yy."_".$mm."_".$dd."_".$h."_".$m."_".($s+1)."_".$from_num_e164."_".$to_num_e164."_".$type."_".$amount;		
		$calls[3] = $yy."_".$mm."_".$dd."_".$h."_".$m."_".$s."_".$from_num_e164."_".$to_num_e164."_".$type."_".($amount-1);		
		$calls[4] = $yy."_".$mm."_".$dd."_".$h."_".$m."_".$s."_".$from_num_e164."_".$to_num_e164."_".$type."_".($amount+1);		
		$calls[5] = $yy."_".$mm."_".$dd."_".$h."_".$m."_".($s-1)."_".$from_num_e164."_".$to_num_e164."_".$type."_".($amount-1);		
		$calls[6] = $yy."_".$mm."_".$dd."_".$h."_".$m."_".($s-1)."_".$from_num_e164."_".$to_num_e164."_".$type."_".($amount+1);		
		$calls[7] = $yy."_".$mm."_".$dd."_".$h."_".$m."_".($s+1)."_".$from_num_e164."_".$to_num_e164."_".$type."_".($amount-1);		
		$calls[8] = $yy."_".$mm."_".$dd."_".$h."_".$m."_".($s+1)."_".$from_num_e164."_".$to_num_e164."_".$type."_".($amount+1);		

		foreach $call (@calls) {
			if (exists $DATA{$call}) {
				print $call." of ".$key." exists!\n";
				$new = 0;
			}	
		}
		if ($new) {
			$DATA{$key} = "$dd.$mm.$yy $h:$m:$s\t$amount\t$from_num\t$from_num_e164\t$to_num\t$to_num_e164\t$plata_port1\t$plata_port2\t$type\n";
		}
	}
	else
	{
		warn "unrecognized string:\n $_\n";
	}
}

close( FILE );
# deleting file
#unlink $logFile;


foreach my $key ( keys %DATA ) {
	my ( $YY, $MM, $DD, $HH, undef, undef, undef, undef, undef, undef ) = split( /_/, $key );
	my $keyf = $YY."_".$MM."_".$DD."_".$HH;		
	$DATAF{$keyf} .= $DATA{$key};
}


foreach my $key ( keys %DATAF )
{
	my ( $YY, $MM, $DD, $HH ) = split( /_/, $key );
	my $path = $destlog_path.$YY;

	if ( !-e $path ) {
		mkdir $path, 0755;
	}
	
	$path = $path."/".$MM;

	if ( !-e $path ) {
		mkdir $path, 0755;
	}


	my $file = $path."/".$DD."_".$HH;

	# if the stats file does not exist and the zipped stats file exists, extract it
	if (( !-f ${file} ) && ( -f ${file}.'.zip' )) {
		print "Stats file ${file} does not exist. Extracting ${file}.zip...\n";
#		warn "$zip_ext ${file}.zip ${DD}_${HH} -d $path\n";
		`$zip_ext ${file}.zip ${DD}_${HH} -d $path`;
	}

	#печатаем данные в файл
	# if the stats file exists, remove the duplicate calls from processed stats and append new calls to a file
	if ( -f $file ) {
		print "Checking for duplicates in stats file ${file}...\n";
		open( FILE, "<".$file ) or die "can't create file '$file': $!\n";
		@values = split( /\n/, $DATAF{$key} );
		while(<FILE>) {
			chomp;
			foreach my $value (@values) {
				if( $value eq $_ ) {
					$value = undef;
					last;
				}
			}
		}
		close( FILE );
		open( FILE, ">>".$file ) or die "can't create file '$file': $!\n";
		foreach my $value (@values) {
			if(defined $value) {
				print FILE $value."\n";
			}
		}
		close( FILE );
	}
	else { # otherwise, write to a new stats file
		print "Writing new stats file ${file}...\n";
		open( FILE, ">".$file ) or die "can't create file '$file': $!\n";
		print FILE $DATAF{$key};
		close( FILE );
	}
	#создаем файл
	chdir $path;
	my $err = `$zip_add ${DD}_${HH}.zip ${DD}_${HH}`;
	chdir $base_path;

	
	# add task to process stats
	#by Khadimulin 20091012: the IP was incorrect 
	#my $request = "http://192.168.169.3:8080/bgbilling/executer?hour=".$HH."&date=".sprintf("%02d.%02d.%02d",$DD,$MM,$YY)."&mid=33&module=load&source=414&action=AddLoadTasks&user=log_proccess&pswd=451782";
	my $request = "http://192.168.169.8:8080/bgbilling/executer?hour=".$HH."&date=".sprintf("%02d.%02d.%02d",$DD,$MM,$YY)."&mid=33&module=load&source=414&action=AddLoadTasks&user=log_proccess&pswd=451782";
	my $request = "http://192.168.169.8:8080/bgbilling/executer?hour=".$HH."&date=".sprintf("%02d.%02d.%02d",$DD,$MM,$YY)."&mid=39&module=load&source=430&action=AddLoadTasks&user=log_proccess&pswd=451782";
	#======================
	my $response = get $request;
	print "Adding task to process the stats for ".sprintf("%02d.%02d.%02d",$DD,$MM,$YY).", ${HH}:00\n";
	#print $response."\n";
}

# нормализация номера
# улучшенная версия
sub normalizeNum2
{
	my $num = shift;
	chomp($num);
	
	# техкод откидываем
	$num =~ s/^05//;
	$num =~ s/^07//;
	
	$before = $num;
	# международный звонок
	if( $num =~ s/^810(\d+)$/$1/ )
	{
		#print "810(*)\t$before\t$num\n";
	}
	# 347xxxxxxx уфимский без 7 в начале -> 7347xxxxxxx
	elsif( $num =~ s/^(347\d{7})$/7$1/ )
	{
		#print "81(*)\t$before\t$num\n";
	}
	# 81XX уфимский справочный
	elsif( $num =~ s/^81(\d*)$/734721$1/ )
	{
		#print "81(*)\t$before\t$num\n";
	}
	# внутри зоны
	elsif( $num =~ s/^82(\d{7})$/7347$1/ )
	{
		#print "82(7)\t$before\t$num\n";
	}
	# внутри зоны с ошибкой
	elsif( $num =~ s/^82(\d{7,})$/7347$1/ )
	{
		#print "82(7+)\t$before\t$num\n";
	}	
	# 8-XXXX-XXXXXX полный российский.
	elsif( $num =~ s/^8(\d{10})$/7$1/ )
	{
		#print "8(10)\t$before\t$num\n";
	}
	# 8-XXXX-XXXXXX-... полный российский, c ошибкой
	elsif( $num =~ s/^8(\d{10,})$/7$1/ )
	{
		#print "8(10+)\t$before\t$num\n";
	}
	# 8-3472-XX-... двузначный уфимский через полный
	elsif( $num =~ s/^83472(\d*)$/73472$1/ )
	{
		#print "83472(*)\t$before\t$num\n";
	}
	# ВСЕ остальные 8-....
	elsif( $num =~ s/^8(\d*)$/7$1/ )
	{
		#print "8(*)\t$before\t$num\n";
		warn "warning: strange TO-num: <$before> -> <$num>\n";
	}
	# с нуля - местные короткие
	elsif( $num =~ s/^0(\d*)$/734720$1/ )
	{
		#print "0(*)\t$before\t$num\n";
	}
	# ВСЕ остальные - местные.
	# щестизначные с 2,3,4,5,6,9
	elsif( $num =~ s/^(2[234569])(\d{5})$/7347$1$2/ )
	{	
		#print "([234569](5))\t$before\t$num\n";
	}
	# с '1' от 3 до 6 знаков
	elsif( $num =~ s/^1(\d{2,5})$/734721$1/ )
	{	
		#print "1(2-5)\t$before\t$num\n";
	}
	# с '7' от 5 до 6 знаков
	elsif( $num =~ s/^27(\d{4,5})$/734727$1/ )
	{	
		#print "7(4-5)\t$before\t$num\n";
	}
	elsif( $num =~ s/^(\d*)$/73472$1/ )
	{
		#print "(*)\t$before\t$num\n";
		warn "warning: strange TO-num: <$before> -> <$num>\n";
	}
	
	return $num;
}


# нормализация номера
# дополняем короткие местные до 10-значных, начинаются с кода
sub normalizeNum
{
	my $num = shift;
	chomp($num); 

	$num =~ s/^05//;
	
	# отбрасываем код выхода на межгород
    unless( $num =~ s/^810(\d+)$/$1/ )
    {
    	# звонок внутри страны
    	
    	# если длина = 6 симв дописываем 3472
    	$before = $num;
		if( $num =~ s/^(\d{6})$/3472$1/ )
		{
			#print "6\t$before\t$num\n";
		}
		# если длина 9 цифр и начинается на 82X-XX-XX-XX, заменяем на 347X-XX-XX-XX
		elsif( $num =~ s/^82(\d{7})$/347$1/ )
		{
			#print "82\t$before\t$num\n";
		}		
    }	
	
	return $num;
} 

# нормализация порта
# CXXYYZZ -> XXYY
# AXXXXXXX -> 9958
#sub normalizePort
#{
#	my $port = shift;
#	chomp($port); 
#
#	if( $port =~ s/^C(\d{4}).*$/$1/ ){;} 
#	elsif( $port =~ s/^(A.*)$/9958/ ){;} 
#	else {$port='0000'};	
#	
#	return $port;
#} 

# приводим к Е.164		
# если 10 цифр - приписываем +7
# если 11 цифр и первая - 8 то заменяем её на 7
#sub num2e164
#{
#	my $num = shift;
#	chomp($num);
#	
#	$before = $num;
#	if( $num =~ s/^(\d{10})$/7$1/ )
#	{
#		#print "10\t$before\t$num\n";
#	}
#	elsif( $num =~ s/^8(\d{10})$/7$1/ )
#	{
#		#print "11\t$before\t$num\n";
#	}	
#	return $num;
#}
